!Token Queue Definition
tagqTokenTX         QUEUE,TYPE
NameToken             CSTRING(256)
Value                 CSTRING(1025)
                    END

_FILEQUEUETX        QUEUE,TYPE
FileName              CSTRING(256)
FileLabel             &FILE
FileRecord            &GROUP
FileView              &VIEW
                    END

_RTF_INFOTX         GROUP,TYPE
MailOpen              LONG
MailFileBof           BOOL
MailFileEof           BOOL
                    END

TXEdit CLASS,TYPE,MODULE('TXCLASS.LIB'),LINK('TXCLASS.LIB')

!Private Properties
m_FEQButtonBar          SHORT, PRIVATE
m_FEQRuler              SHORT, PRIVATE
m_FEQText               SHORT, PRIVATE
m_FEQStatusBar          SHORT, PRIVATE
m_FEQVSSpell            SHORT, PRIVATE
ControlChars            BYTE(1), PRIVATE
PageView                BYTE(1), PRIVATE
WorkFileName            CSTRING(256),PRIVATE
m_qToken                &tagqTokenTX
m_rWindow               &WINDOW
MailFileQueue           &_FILEQUEUETX,PRIVATE
MailDocumentBuffer      STRING(65521),PRIVATE
MailDocumentModified    BOOL,PRIVATE
MailFilterValue         CSTRING(256),PRIVATE
MailOrderValue          CSTRING(256),PRIVATE
MailFirstRecord         LONG,PRIVATE
MailLastRecord          LONG,PRIVATE
MailRecords             LONG,PRIVATE
MailFileName            &FILE
MailFileView            &VIEW
MailFileOpen            BOOL,PRIVATE
MailFileEnd             SHORT,PRIVATE
PopupMailMerge          LONG,PRIVATE  ! Mail Merge popup dialog is running.    Hold the thread when running.
!Public Properties
hWnd                    LONG
m_rWindow               &WINDOW
m_Init                  BYTE
Measurements            BYTE
MetaItems               BYTE
MetaList                CSTRING(128),DIM(200)
TXLicense               STRING(120)
JSMergeFileName         STRING(120)
Info                    LIKE(_RTF_INFOTX)
PopUpFlatButtons        LONG
!Methods
Init                    PROCEDURE(*WINDOW iWindow,SHORT FEQText,<SHORT FEQButtonBar>,<SHORT FEQRuler>,<SHORT FEQStatusBar>,<STRING LicenseString>),VIRTUAL
Kill                    PROCEDURE(),VIRTUAL
ChangeZoom              PROCEDURE(LONG NewZoom),VIRTUAL
BLOBToMetaFile          PROCEDURE(LONG CtlWidth,LONG CtlHeight,<BLOB BlobVal>,<STRING PassStr>),LONG,PROC,VIRTUAL
BLOBToOneMetaFile       PROCEDURE(LONG CtlWidth,LONG CtlHeight,BLOB BlobVal),LONG,PROC,VIRTUAL
BookmarkCount           PROCEDURE(),LONG,VIRTUAL
BookmarkGetText         PROCEDURE(LONG FieldId),STRING,VIRTUAL
BookmarkGoToById        PROCEDURE(LONG FieldId),VIRTUAL
BookmarkGoToByTitle     PROCEDURE(STRING BookmarkTitle),VIRTUAL
BookmarkInsert          PROCEDURE(STRING BookmarkTitle),VIRTUAL
BulletsDecreaseLevel    PROCEDURE(),VIRTUAL
BulletsIncreaseLevel    PROCEDURE(),VIRTUAL
CanUndo                 PROCEDURE(),LONG,VIRTUAL
CanRedo                 PROCEDURE(),LONG,VIRTUAL
ClearMetaList           PROCEDURE(),VIRTUAL
CloseJSMergeFile        PROCEDURE(),VIRTUAL
ColorMailMergeField     PROCEDURE(LONG FieldColor),VIRTUAL
DeleteField             PROCEDURE(LONG ID),LONG,VIRTUAL
DeleteCurrentField      PROCEDURE(),LONG,PROC,VIRTUAL
DeleteWMFs              PROCEDURE(),VIRTUAL
DocToMetaFile           PROCEDURE(),LONG,VIRTUAL
EasyInit                PROCEDURE(*WINDOW iWindow, SHORT FEQText,<SHORT FEQButtonBar>,<SHORT FEQRuler>,<SHORT FEQStatusBar>)
Find                    PROCEDURE(),VIRTUAL
FindReplace             PROCEDURE(),VIRTUAL
FormatDoc               PROCEDURE(),VIRTUAL
FormatFrame             PROCEDURE(),VIRTUAL
FormatImage             PROCEDURE(),VIRTUAL
FormatTable             PROCEDURE(),VIRTUAL
GetCurrentHyperlinkData PROCEDURE(*CSTRING LinkText, *CSTRING LinkURL),LONG,VIRTUAL
GetCurrentInputPosition PROCEDURE(*LONG PageNo, *LONG LineNo, *LONG ColumnNo),LONG,VIRTUAL,PROC
GetDataSize             PROCEDURE(LONG DataFormat, BYTE CurSelection=0),LONG,VIRTUAL
GetHyperlinkData        PROCEDURE(LONG ID,*CSTRING LinkText, *CSTRING LinkURL),LONG,VIRTUAL
GetFromBLOB             PROCEDURE(*BLOB BLOBVal),VIRTUAL
GetFieldData            PROCEDURE(LONG ID,*CSTRING FieldText, *CSTRING FieldData),LONG,PROC,VIRTUAL
GetFieldURL             PROCEDURE(LONG ID),STRING,VIRTUAL
GetFieldType            PROCEDURE(LONG ID),LONG,VIRTUAL
GetRTFFromMemo          PROCEDURE(*? MemoField),VIRTUAL
GetTokenListCount       PROCEDURE(),LONG,VIRTUAL
GetTokenListItem        PROCEDURE(LONG ItemNo),STRING,VIRTUAL
GetTokenListValue       PROCEDURE(LONG ItemNo),STRING,VIRTUAL
GetTXDataSize           PROCEDURE(BYTE IncludeMargins=0),LONG,VIRTUAL
GoToURL                 PROCEDURE(STRING URL),VIRTUAL
GoToChar                PROCEDURE(LONG Offset),VIRTUAL
HeaderFooterActivate    PROCEDURE(LONG HeaderFooter),LONG,PROC,VIRTUAL
HighLightHyperlinks     PROCEDURE(LONG LinkColor,BYTE Underline),VIRTUAL
InitMailFile            PROCEDURE(STRING FileName, FILE FileLabel, *GROUP FileRecord, VIEW FileView),VIRTUAL
InsertDateTime          PROCEDURE(),VIRTUAL
InsertFPHeader          PROCEDURE(BYTE InsertHeader,<STRING HeaderText>),VIRTUAL
InsertHeader            PROCEDURE(BYTE InsertHeader,<STRING HeaderText>),VIRTUAL
InsertFPFooter          PROCEDURE(BYTE InsertFOOTER,<STRING FOOTERText>),VIRTUAL
InsertFooter            PROCEDURE(BYTE InsertFOOTER,<STRING FOOTERText>),VIRTUAL
InsertHyperLink         PROCEDURE(*CSTRING LinkText, *CSTRING LinkURL),VIRTUAL
InsertImage             PROCEDURE(BYTE AsChar, SHORT ImageSaveMode=1),VIRTUAL
InsertObject            PROCEDURE(BYTE AsChar),VIRTUAL
InsertPageNumbers       PROCEDURE(BYTE InsertIt),VIRTUAL
InsertTable             PROCEDURE(),VIRTUAL
InsertText              PROCEDURE(STRING InText),VIRTUAL
InsertTextFile          PROCEDURE(),VIRTUAL
InsertToken             PROCEDURE(STRING TokenText,STRING TokenID),VIRTUAL
IsBLOBOK                PROCEDURE(*BLOB BLOBVal),LONG,VIRTUAL
ListAttrDialog          PROCEDURE(),VIRTUAL
LoadFile                PROCEDURE(<STRING FileToLoad>),VIRTUAL
LoadTXFromCSTRING       PROCEDURE(*CSTRING SavedString),VIRTUAL
LoadTXFromSTRING        PROCEDURE(*STRING SavedString),VIRTUAL
MailFilter              PROCEDURE(),VIRTUAL
MailInsert              PROCEDURE(),VIRTUAL
MailLocate              PROCEDURE(LONG Direction, <*STRING FieldName>), BOOL, PROC,VIRTUAL
MailMerge               PROCEDURE(BYTE UseFlatButtons=0),VIRTUAL
MailMergeRecord         PROCEDURE(*GROUP MergeFileRecord),VIRTUAL
MailMergeRestore        PROCEDURE(),VIRTUAL
MailMergeToolbox        PROCEDURE(BYTE UseFlatButtons=0),VIRTUAL
MailPrinter             PROCEDURE(),VIRTUAL
MailScreen              PROCEDURE(BYTE ScreenOn),VIRTUAL
OpenJSMergeFile         PROCEDURE(STRING FileName),VIRTUAL
ParagraphDialog         PROCEDURE(),VIRTUAL
PrintDoc                PROCEDURE(BYTE PrintToDefault=0),LONG,PROC,VIRTUAL
PrintDocToMetaFiles     PROCEDURE(),LONG,VIRTUAL
PutToBLOB               PROCEDURE(*BLOB BLOBVal),VIRTUAL
ReadInfo                PROCEDURE(),VIRTUAL
ReplaceMailMergeToken   PROCEDURE(STRING TokenText, STRING NewText),VIRTUAL
ReplaceToken            PROCEDURE(STRING TokenID, STRING TokenText),LONG,PROC,VIRTUAL
ReplaceTokenByText      PROCEDURE(STRING TokenText, STRING NewTokenText),LONG,PROC,VIRTUAL
ResizeStatusBar         PROCEDURE(),VIRTUAL
RestoreMergeFieldColors PROCEDURE(),VIRTUAL
RunPopupMailMerge       PROCEDURE(),VIRTUAL
SaveRTFToMemo           PROCEDURE(*? MemoField),VIRTUAL
SaveAs                  PROCEDURE(STRING FileName, BYTE FileFormat=0),VIRTUAL
SaveCurFile             PROCEDURE(),VIRTUAL
SaveFileAs              PROCEDURE(),VIRTUAL
SaveTXToCSTRING         PROCEDURE(*CSTRING SavedString,*LONG DataSize,BYTE IncludeMargins=0),VIRTUAL
SaveTXToSTRING          PROCEDURE(*STRING SavedString,*LONG DataSize,BYTE IncludeMargins=0),VIRTUAL
SaveToMemory            PROCEDURE(*STRING SavedString,*LONG BytesWritten, LONG DataFormat, BYTE CurSelection=0),VIRTUAL
SelectAll               PROCEDURE(),VIRTUAL
SelectWord              PROCEDURE(*LONG StartPos,*LONG EndPos),VIRTUAL
SetColor                PROCEDURE(),VIRTUAL
SetBackgroundColor      PROCEDURE(),VIRTUAL
SetScaleUnits           PROCEDURE(BYTE ScaleUnits),VIRTUAL
ShowControlChars        PROCEDURE(),VIRTUAL
ShowGridLines           PROCEDURE(),VIRTUAL,VIRTUAL
ShowPageView            PROCEDURE(BYTE PageView),VIRTUAL
VTSpellCheck            PROCEDURE(),VIRTUAL
VSSpellCheck            PROCEDURE(SHORT FEQVSSpell),VIRTUAL
WTSpellCheck            PROCEDURE(SHORT FEQWTSpell),VIRTUAL
VSSpellInit             PROCEDURE(SHORT FEQVSSpell),VIRTUAL
VSCheckTyping           PROCEDURE(),VIRTUAL
VSProcessTypingError    PROCEDURE(LONG SelStart,LONG SelLength,SHORT Suggestions),VIRTUAL
TXFontDialog            PROCEDURE(),VIRTUAL
WordCount               PROCEDURE(),LONG,VIRTUAL
Undo                    PROCEDURE(),VIRTUAL
UpdateHyperLinkURL      PROCEDURE(LONG ID,*CSTRING LinkURL),VIRTUAL
UpdateField             PROCEDURE(LONG ID,<*CSTRING FieldText>,<*CSTRING FieldToken>),LONG,PROC,VIRTUAL
Redo                    PROCEDURE(),VIRTUAL
SelectObject            PROCEDURE(SHORT bInsertAsCharacter,SHORT pTXControl,SHORT nLeft,SHORT nTop),PRIVATE
SetFocusToTextControl   PROCEDURE(),VIRTUAL
SetListType             PROCEDURE(LONG ListType),VIRTUAL
SetNumberingType        PROCEDURE(LONG NumberingFormat),VIRTUAL
SetPageHeight           PROCEDURE(LONG PageHeight),VIRTUAL
SetPageWidth            PROCEDURE(LONG PageWidth),VIRTUAL
ShowPopUpMenu           PROCEDURE(),VIRTUAL
ShowToolbox             PROCEDURE(STRING ToolBoxType),VIRTUAL
FormatDocDialog         PROCEDURE(WINDOW pWindow,SHORT pTXText),BYTE,PRIVATE
NewDoc                  PROCEDURE(Byte Force=0),LONG,VIRTUAL
TXCut                   PROCEDURE(),VIRTUAL
TXCopy                  PROCEDURE(),VIRTUAL
TXPaste                 PROCEDURE(),VIRTUAL
TXCanCopy               PROCEDURE(),LONG,VIRTUAL
TXCanPaste              PROCEDURE(),LONG,VIRTUAL
TXSetEditMode           PROCEDURE(LONG EditMode),VIRTUAL
StreamToMetaFile        PROCEDURE(LONG CtlWidth,LONG CtlHeight,<*CSTRING TXData>,<STRING PassStr>),LONG,PRIVATE,VIRTUAL
CheckForHeader          PROCEDURE(*CSTRING DataString, *LONG DataSize, *DOC_DATA Doc),LONG,PROC,PRIVATE,VIRTUAL
               END
!_EndOfInclude_

